import { ISerializers, WidgetModel, WidgetView } from '@jupyter-widgets/base';
import { EdgeSingular, NodeSingular } from 'cytoscape';
import { CytoscapeView } from './widget';
export declare class ElementModel extends WidgetModel {
    defaults(): {
        removed: boolean;
        selected: boolean;
        selectable: boolean;
        classes: string;
        data: {};
        _model_module: string;
        _model_name: string;
        _model_module_version: string;
        _view_module: string;
        _view_name: string;
        _view_module_version: string;
        _view_count: number;
    };
    asCyObj(): {
        data: any;
        selectable: any;
        classes: any;
    };
}
export declare class NodeModel extends ElementModel {
    defaults(): {
        _model_name: string;
        _model_module: any;
        _model_module_version: any;
        _view_name: string;
        _view_module: any;
        _view_module_version: any;
        group: string;
        position: {};
        locked: boolean;
        grabbable: boolean;
        pannable: boolean;
        removed: boolean;
        selected: boolean;
        selectable: boolean;
        classes: string;
        data: {};
        _view_count: number;
    };
    asCyObj(): {
        group: any;
        position: any;
        locked: any;
        grabbable: any;
        pannable: any;
        data: any;
        selectable: any;
        classes: any;
    };
    static model_name: string;
    static model_module: any;
    static model_module_version: any;
    static view_name: string;
    static view_module: any;
    static view_module_version: any;
}
export declare class EdgeModel extends ElementModel {
    defaults(): {
        _model_name: string;
        _model_module: any;
        _model_module_version: any;
        _view_name: string;
        _view_module: any;
        _view_module_version: any;
        group: string;
        pannable: boolean;
        removed: boolean;
        selected: boolean;
        selectable: boolean;
        classes: string;
        data: {};
        _view_count: number;
    };
    asCyObj(): {
        group: any;
        pannable: any;
        data: any;
        selectable: any;
        classes: any;
    };
    static model_name: string;
    static model_module: any;
    static model_module_version: any;
    static view_name: string;
    static view_module: any;
    static view_module_version: any;
}
export declare class GraphModel extends WidgetModel {
    defaults(): {
        _model_name: string;
        _model_module: any;
        _model_module_version: any;
        nodes: never[];
        edges: never[];
        _view_module: string;
        _view_name: string;
        _view_module_version: string;
        _view_count: number;
    };
    static serializers: ISerializers;
    static model_module: any;
    static model_module_version: any;
}
export declare class ElementView extends WidgetView {
    cytoscapeView: CytoscapeView;
    protected elem: NodeSingular | EdgeSingular;
    constructor(params: any);
    valueChanged(): void;
}
export declare class NodeView extends ElementView {
    private node;
    constructor(params: any);
}
export declare class EdgeView extends ElementView {
    constructor(params: any);
}
