import { DOMWidgetModel, DOMWidgetView, ISerializers, Dict } from '@jupyter-widgets/base';
import '../css/widget.css';
import cytoscape, { Core } from 'cytoscape';
import 'tippy.js/themes/material.css';
import { NodeModel, EdgeModel } from './graph';
export declare class CytoscapeModel extends DOMWidgetModel {
    defaults(): any;
    initialize(attributes: any, options: any): void;
    static serializers: ISerializers;
    private processMessage;
    private forEachView;
    static model_name: string;
    static model_module: any;
    static model_module_version: any;
    static view_name: string;
    static view_module: any;
    static view_module_version: any;
    views: Dict<Promise<CytoscapeView>>;
}
export declare class CytoscapeView extends DOMWidgetView {
    cytoscape_obj: Core;
    is_rendered: boolean;
    nodeViews: any;
    edgeViews: any;
    monitored: any;
    render(): void;
    value_changed(): void;
    private _updateViewLists;
    listenForUserEvents(): void;
    init_render(): void;
    private _updateMinZoom;
    private _updateMaxZoom;
    private _updateZoomingEnabled;
    private _updateUserZoomingEnabled;
    private _updatePanningEnabled;
    private _updateUserPanningEnabled;
    private _updateBoxSelectionEnabled;
    private _updateSelectionType;
    private _updateAutolock;
    private _updateAutoUngrabify;
    private _updateAutoUnselectify;
    private _updateLayout;
    private _updateStyle;
    private _resize;
    /**
     * Add the listeners for traits that are common to nodes and edges
     */
    _addElementListeners(ele: cytoscape.CollectionReturnValue, view: DOMWidgetView): void;
    addNodeModel(NodeModel: NodeModel): Promise<DOMWidgetView>;
    removeNodeView(nodeView: any): void;
    addEdgeModel(EdgeModel: EdgeModel): Promise<DOMWidgetView>;
    removeEdgeView(edgeView: any): void;
}
